<?php

class Validation extends Form{

    /*
     * Vérifie si le champ est vide
     * @param   var
     * @param   string nom du champ
     * @return  bool
     */
    static function notEmpty($var,$name){
        if(empty($var)){
            return 'error';
        }else{
            return true;
        }
    }

    /*
     * Vérifie s'il s'agit bien d'une date
     * @param   string (date)
     * @return  bool
     */
    static function isDate($date){
        if(Validate::isDate($date)){
            return true;
        }else{
            return 'error';
        }
    }
    
    /*
     * Vérifie s'il s'agit bien d'un email
     * @param   string (email)
     * @return  bool
     */
    static function isEmail($email){
        if(preg_match('/^[a-z0-9!#$%&\'*+\/=?^`{}|~_-]+[.a-z0-9!#$%&\'*+\/=?^`{}|~_-]*@[a-z0-9]+[._a-z0-9-]*\.[a-z0-9]+$/ui', $email)){
            return true;
        }else{
            return 'error';
        }
    }

    /*
     * Vérifie si l'url est bien valide
     * @param   string (url)
     * @return  bool
     */
    static function isUrl($url){
        if(preg_match('/^([[:alnum:]]|[~:#%&_=\(\)\.\? \+\-@\/])+$/ui',$url)){
            return true;
        }else{
            return 'error';
        }
    }

    /*
     * Vérifie si le captcha est valide
     * @param   string (date)
     * @return  bool
     */
    static function isCaptcha($captcha){
        $captchaSession = Session::read('captcha');
        if($captcha==$captchaSession){
            return true;
        }else{
            return 'error';
        }
    }

}

?>
